// SndfxDlg.cpp : implementation file
//

#include "stdafx.h"

#include <ctype.h>

#include "soundfx.h"
#include "SndfxDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CSndfxDlg dialog

CSndfxDlg::CSndfxDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSndfxDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSndfxDlg)
	m_sBaseAddress = _T("");
	m_iDma16 = -1;
	m_iDma8 = -1;
	m_iInterrupt = -1;
	m_sMidiBase = _T("");
	m_iType = -1;
	m_sAdlibTimeout = _T("");
	m_iTrace = -1;
	m_bAutoLoad = FALSE;
	m_bJoyPort = FALSE;
	m_sEmuBase = _T("");
	m_sEmuTimeout = _T("");
	m_iSynth = -1;
	m_sFxBuffer = _T("");
	//}}AFX_DATA_INIT
	m_sDspInterval = _T("");
    m_bJoyPortEnable = TRUE;
    m_bEnableEmu = TRUE;
}


void CSndfxDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSndfxDlg)
	DDX_Control(pDX, IDC_FX_BUFFER, m_cbxFxBuffer);
	DDX_Control(pDX, IDC_TYPE, m_cbxType);
	DDX_Control(pDX, IDC_EMU_TIMEOUT, m_cbxEmuTimeout);
	DDX_Control(pDX, IDC_EMU, m_cbxEmu);
	DDX_Control(pDX, IDC_JOYPORT, m_cJoyPort);
	DDX_Control(pDX, IDC_LABEL_TRACE_LEVEL, m_cTraceLabel);
	DDX_Control(pDX, IDC_AUTOLOAD, m_cbtnAutoLoad);
	DDX_Control(pDX, IDC_TRACE_LEVEL, m_cbxTrace);
	DDX_Control(pDX, IDC_DMA16, m_cbxDma16);
	DDX_Control(pDX, IDC_MIDI, m_cbxMidi);
	DDX_Control(pDX, IDC_ADLIB_TIMEOUT, m_cbxAdlib);
	DDX_Control(pDX, IDC_BASE, m_cbxBase);
	DDX_CBString(pDX, IDC_BASE, m_sBaseAddress);
	DDV_MaxChars(pDX, m_sBaseAddress, 3);
	DDX_CBIndex(pDX, IDC_DMA16, m_iDma16);
	DDX_CBIndex(pDX, IDC_DMA8, m_iDma8);
	DDX_CBIndex(pDX, IDC_INTERRUPT, m_iInterrupt);
	DDX_CBString(pDX, IDC_MIDI, m_sMidiBase);
	DDV_MaxChars(pDX, m_sMidiBase, 3);
	DDX_CBIndex(pDX, IDC_TYPE, m_iType);
	DDX_CBString(pDX, IDC_ADLIB_TIMEOUT, m_sAdlibTimeout);
	DDV_MaxChars(pDX, m_sAdlibTimeout, 4);
	DDX_CBIndex(pDX, IDC_TRACE_LEVEL, m_iTrace);
	DDX_Check(pDX, IDC_AUTOLOAD, m_bAutoLoad);
	DDX_Check(pDX, IDC_JOYPORT, m_bJoyPort);
	DDX_CBString(pDX, IDC_EMU, m_sEmuBase);
	DDV_MaxChars(pDX, m_sEmuBase, 3);
	DDX_CBString(pDX, IDC_EMU_TIMEOUT, m_sEmuTimeout);
	DDV_MaxChars(pDX, m_sEmuTimeout, 4);
	DDX_CBIndex(pDX, IDC_SYNTH_TYPE, m_iSynth);
	DDX_CBString(pDX, IDC_FX_BUFFER, m_sFxBuffer);
	DDV_MaxChars(pDX, m_sFxBuffer, 4);
	//}}AFX_DATA_MAP

  pDX->PrepareCtrl( IDC_BASE);
  DDV_MinMaxLong( pDX, strtol( m_sBaseAddress.GetBuffer( 0), NULL, 16), 0x100, 0x3ff);

  pDX->PrepareCtrl( IDC_MIDI);
  DDV_MinMaxLong( pDX, strtol( m_sMidiBase.GetBuffer( 0), NULL, 16), 0x100, 0x3ff);
  
  pDX->PrepareCtrl( IDC_ADLIB_TIMEOUT);
  DDV_MinMaxLong( pDX, strtol( m_sAdlibTimeout.GetBuffer( 0), NULL, 10), 0, 1000);

  pDX->PrepareCtrl( IDC_FX_BUFFER);
  DDV_MinMaxLong( pDX, strtol( m_sFxBuffer.GetBuffer( 0), NULL, 10), 0, 1000);

  pDX->PrepareCtrl( IDC_EMU);
  DDV_MinMaxLong( pDX, strtol( m_sEmuBase.GetBuffer( 0), NULL, 16), 0x100, 0xfff);

  pDX->PrepareCtrl( IDC_EMU_TIMEOUT);
  DDV_MinMaxLong( pDX, strtol( m_sEmuTimeout.GetBuffer( 0), NULL, 10), 0, 1000);
}


BEGIN_MESSAGE_MAP(CSndfxDlg, CDialog)
	//{{AFX_MSG_MAP(CSndfxDlg)
	ON_CBN_EDITUPDATE(IDC_BASE, OnEditupdateBase)
	ON_CBN_EDITUPDATE(IDC_MIDI, OnEditupdateMidi)
	ON_BN_CLICKED(IDC_DEFAULTS, OnDefaults)
	ON_CBN_EDITUPDATE(IDC_ADLIB_TIMEOUT, OnEditupdateAdlibTimeout)
	ON_CBN_SELCHANGE(IDC_TYPE, OnSelchangeType)
	ON_WM_HELPINFO()
	ON_CBN_EDITUPDATE(IDC_EMU, OnEditupdateEmu)
	ON_CBN_EDITUPDATE(IDC_EMU_TIMEOUT, OnEditupdateEmuTimeout)
	ON_CBN_EDITUPDATE(IDC_FX_BUFFER, OnEditupdateFxBuffer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CSndfxDlg message handlers

/*
 * Dialog initialisation
 */
BOOL CSndfxDlg::OnInitDialog() 
  {
  CDialog::OnInitDialog();
	
  // enable DMA16 & MIDI if SB16
  m_cbxDma16.EnableWindow( m_iType >= 4);
  m_cbxMidi.EnableWindow( m_iType >= 4);

  // enable EMU if AWE32
  m_cbxEmu.EnableWindow( m_bEnableEmu && m_iType >= 5);
  m_cbxEmuTimeout.EnableWindow( m_bEnableEmu && m_iType >= 5);
  if ( !m_bEnableEmu)
    {
    int iCount = m_cbxType.GetCount();
    while ( iCount-- > 5)
      m_cbxType.DeleteString( 5);
    if ( m_iType >= 5)
      {
      m_iType = 4;
      UpdateData( FALSE);
      }
    }
  
  // Enable joyport checkbox if required
  m_cJoyPort.EnableWindow( m_bJoyPortEnable);

  // Show the trace level control if eval version of VDD
  m_cbxTrace.ShowWindow( m_iTrace >= 0 ? SW_SHOW : SW_HIDE);
  m_cTraceLabel.ShowWindow( m_iTrace >= 0 ? SW_SHOW : SW_HIDE);

  return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
  }


/*
 * Default button pressed
 */
void CSndfxDlg::OnDefaults() 
  {
  // Set default values
  m_iType = 4; // 4= SB16
  m_sBaseAddress = "220";
  m_iInterrupt = 5 - 2; // IRQ5
  m_sMidiBase = "330";
  m_iDma8 = 1; // DMA1
  m_iDma16 = 5; // DMA5
  m_sAdlibTimeout = "8";
  m_sDspInterval = "15";
  m_bJoyPort = TRUE;
  m_sEmuBase = "620";
  m_sEmuTimeout = "16";
  m_iSynth = 3; // 0= Adlib device, 1= Hardware direct, 2... emulate
  m_bAutoLoad = TRUE;
  m_iTrace = 1;
  m_sFxBuffer = "175"; // 175 for NT4/DirectX 3/AWE32.  50 is better for Win2K/DirectX 7/SBLive
  UpdateData( FALSE);

  OnSelchangeType();
  }


/*
 * Ensure valid hex number
 */
static void ValidHex( CComboBox& cbx) 
  {
  CString sText;
  cbx.GetWindowText( sText);
  int iValid = 0;
  const char* psz = sText.GetBuffer( 0);
  char c;
  while ( '\0' != (c = *psz++))
    {
    if ( isxdigit( c))
      ++iValid;
    else
      {
      cbx.SetWindowText( sText.Left( iValid));
      cbx.SetEditSel( iValid, -1);
      break;
      }
    }
  }


/*
 * Ensure valid decimal number
 */
static void ValidDecimal( CComboBox& cbx) 
  {
  CString sText;
  cbx.GetWindowText( sText);
  int iValid = 0;
  const char* psz = sText.GetBuffer( 0);
  char c;
  while ( '\0' != (c = *psz++))
    {
    if ( isdigit( c))
      ++iValid;
    else
      {
      cbx.SetWindowText( sText.Left( iValid));
      cbx.SetEditSel( iValid, -1);
      break;
      }
    }
  }


/*
 * Base address text changed
 */
void CSndfxDlg::OnEditupdateBase() 
  {
  ValidHex( m_cbxBase);
  }


/*
 * Midi address changed
 */
void CSndfxDlg::OnEditupdateMidi() 
  {
  ValidHex( m_cbxMidi);
  }


/*
 * Adlib text changed
 */
void CSndfxDlg::OnEditupdateAdlibTimeout() 
  {
  ValidDecimal( m_cbxAdlib);
  }


/*
 * Output interval text changed
 */
void CSndfxDlg::OnEditupdateDspInterval() 
  {
  ValidDecimal( m_cbxDsp);
  }


/*
 * Card type changed
 */
void CSndfxDlg::OnSelchangeType() 
  {
  if ( UpdateData())
    {
    // enable DMA16 & MIDI if SB16
    m_cbxDma16.EnableWindow( m_iType >= 4);
    m_cbxMidi.EnableWindow( m_iType >= 4);
    // enable EMU if AWE32
    m_cbxEmu.EnableWindow( m_bEnableEmu && m_iType >= 5);
    m_cbxEmuTimeout.EnableWindow( m_bEnableEmu && m_iType >= 5);
    }
  }


/*
 * F1 help requested
 */
BOOL CSndfxDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
  {
  if ( HELPINFO_WINDOW == pHelpInfo->iContextType)
    {
    // Show popup help
    AfxGetApp()->WinHelp( pHelpInfo->dwContextId, HELP_CONTEXTPOPUP);
    return TRUE;
    }
  return CDialog::OnHelpInfo( pHelpInfo);
  }


/*
 *  EMU8000 base address change
 */
void CSndfxDlg::OnEditupdateEmu() 
  {
  ValidHex( m_cbxEmu);
  }


void CSndfxDlg::OnEditupdateEmuTimeout() 
  {
  ValidDecimal( m_cbxEmuTimeout);
  }


/*
 * DSP output buffer size
 */
void CSndfxDlg::OnEditupdateFxBuffer() 
  {
  ValidDecimal( m_cbxFxBuffer);
  }
