// CtrlPan.cpp
// Source for CControlPanel

#include "stdafx.h"
#include "ctrlpan.h"

// static data
CControlPanel* CControlPanel::m_pThis = NULL;

CControlPanel::CControlPanel()
{
    // Set up the static object pointer
    m_pThis = this;
}

CControlPanel::~CControlPanel()
{
}

//////////////////////////////////////////////////////////////////////////////              
// Callback function (exported)
// static member functions (callbacks)
AFX_API_EXPORT LONG APIENTRY CControlPanel::CPlApplet(HWND hwndCPl, UINT  uMsg,
                                       LONG lParam1, LONG lParam2)
{
    // Get a pointer to the C++ object
    CControlPanel* pCtrl = m_pThis;
    ASSERT(pCtrl);

    switch (uMsg) {
    case CPL_DBLCLK:
        return pCtrl->OnDblclk(hwndCPl, lParam1, lParam2);

    case CPL_EXIT:
        return pCtrl->OnExit();

    case CPL_GETCOUNT:
        return pCtrl->OnGetCount();

    case CPL_INIT:
        return pCtrl->OnInit();

    case CPL_NEWINQUIRE:
        return pCtrl->OnInquire(lParam1, (NEWCPLINFO*)lParam2);

    case CPL_INQUIRE:
        return 0; // not handled

    case CPL_SELECT:
        return pCtrl->OnSelect(lParam1, lParam2);

    case CPL_STOP:
        return pCtrl->OnStop(lParam1, lParam2);

    default:
        break;
    }

    return 1; // not processed
}

/////////////////////////////////////////////////////////////////////////////////////////
// Default command handlers

LONG CControlPanel::OnExit()
{
    return 0; // OK
}

LONG CControlPanel::OnGetCount()
{
    return 1; // default is support for one dialog box
}

LONG CControlPanel::OnInit()
{
    return 1; // OK
}

LONG CControlPanel::OnSelect(UINT, LONG) 
{
    return 1; // not handled
}

LONG CControlPanel::OnStop(UINT, LONG) 
{
    return 1; // not handled
}
