/****************************************************************************
 * portio.h                                                                 *
 * Global definitions for the direct port IO driver                         *
 *                                                                          *
 * Copyright (c)1999 Lawrence Rust                                          *
 * Created by Lawrence Rust, Software Systems Consultants, Cambridge, UK.   *
 * lvr@softsystem.co.uk. Tel/Fax +44 1223 862391                            *
 *                                                                          *
 * Runtime:     Windows NT 4.0                                              *
 *__________________________________________________________________________*
 *                                                                          *
 * Revision History:                                                        *
 *                                                                          *
 * No.   Date     By   Reason                                               *
 *--------------------------------------------------------------------------*
 * 100 08 Jun 99  lvr  Created                                              *
 *__________________________________________________________________________*/
#ifndef PORTIO_H
#define PORTIO_H 0x100

/* Dependencies */
#ifdef __cplusplus
extern "C" {
#endif

#include <ntddk.h>

#ifdef __cplusplus
}
#endif

#include "portctl.h"               // Private ioctl defintions


/*
 * Constants
 */
#define _WIDETEXT( quote) L##quote
#define WIDETEXT( quote) _WIDETEXT( quote)

#define SYMBOLIC_NAME  L"\\DosDevices\\" WIDETEXT( PORTIO_DEVICE_NAME)


/*
 * The device extension
 */
typedef struct  DEVICE_EXTENSION
  {
  PDEVICE_OBJECT    pDeviceObject;      /* -> Parent device */

  UNICODE_STRING    suSymbolicName;     /* Symbolic device name */
  WCHAR             aswSymbolicName[ sizeof( SYMBOLIC_NAME)];

  ULONG             ulAddressSpace;
  PVOID             pvIOPortBase;
  } DEVICE_EXTENSION;

#endif /* ndef PORTIO_H*/
/* End of file */
