/****************************************************************************
 * EMU8000.H                                                                *
 * Interface to the EMU8000 synthesiser emulator                            *
 *                                                                          *
 * Copyright (c)1998 Lawrence Rust                                          *
 * Created by Lawrence Rust, Software Systems Consultants, Cambridge, UK.   *
 * lvr@softsystem.co.uk. Tel/Fax +44 1223 862391                            *
 *__________________________________________________________________________*
 *                                                                          *
 * Revision History:                                                        *
 *                                                                          *
 * No.   Date     By   Reason                                               *
 *--------------------------------------------------------------------------*
 * 100 10 Jun 99  lvr  Created                                              *
 *__________________________________________________________________________*/
#ifndef EMU8000_H
#define EMU8000_H 0x100

/* Dependencies */
#pragma warning ( disable : 4201) /* nonstandard extension used : nameless struct/union */
#pragma warning ( disable : 4214) /* nonstandard extension used : bit field types other than int */
#include <windows.h>
#pragma warning ( default : 4201)
#pragma warning ( default : 4214)

/* Types */
typedef struct SEmu8000 SEmu8000;
struct SSbvdd;

/* Functions */
extern SEmu8000* Emu8000Init( const struct SSbvdd*);
extern void Emu8000Final( register SEmu8000*);
extern void Emu8000Terminate( register SEmu8000*);

extern WORD __fastcall Emu8000Read( register SEmu8000*, WORD wPort);
extern void __fastcall Emu8000Write( register SEmu8000*, WORD wPort, WORD);

extern BOOL Emu8000SetConfig(
  register SEmu8000*,
  WORD wBase
);
extern void Emu8000SetCacheTimeout( register SEmu8000*, unsigned);

#endif /* ndef EMU8000_H */
/* End of file */
