/****************************************************************************
 * JOYPORT.H                                                                *
 * Interface to the games port emulator                                     *
 *                                                                          *
 * Copyright (c)1999 Lawrence Rust                                          *
 * Created by Lawrence Rust, Software Systems Consultants, Cambridge, UK.   *
 * lvr@softsystem.co.uk. Tel/Fax +44 1223 862391                            *
 *__________________________________________________________________________*
 *                                                                          *
 * Revision History:                                                        *
 *                                                                          *
 * No.   Date     By   Reason                                               *
 *--------------------------------------------------------------------------*
 * 100 27 Apr 99  lvr  Created                                              *
 *__________________________________________________________________________*/
#ifndef JOYPORT_H
#define JOYPORT_H 0x100

/* Dependencies */
#pragma warning( disable : 4201) /* nonstandard extension used : nameless struct/union */
#pragma warning( disable : 4214) /* nonstandard extension used : bit field types other than int */
#include <windows.h>
#pragma warning( default : 4201)
#pragma warning( default : 4214)

/* Types */
struct SSbvdd;
typedef struct SGame SGame;

/* Functions */
extern SGame* GameInit( const struct SSbvdd*);
extern void GameFinal( register SGame*);
extern void GameTerminate( register SGame*);
extern BYTE __fastcall GameRead( register SGame*);
extern void __fastcall GameWrite( register SGame*, BYTE);

#endif /* ndef JOYPORT_H */
/* End of file */
