/****************************************************************************
 * MIXER.H                                                                  *
 * Interface to the CT1745 mixer emulato                                    *
 *                                                                          *
 * Copyright (c)1998 Lawrence Rust                                          *
 * Created by Lawrence Rust, Software Systems Consultants, Cambridge, UK.   *
 * lvr@softsystem.co.uk. Tel/Fax +44 1223 862391                            *
 *__________________________________________________________________________*
 *                                                                          *
 * Revision History:                                                        *
 *                                                                          *
 * No.   Date     By   Reason                                               *
 *--------------------------------------------------------------------------*
 * 100 02 Oct 98  lvr  Created                                              *
 *__________________________________________________________________________*/
#ifndef MIXER_H
#define MIXER_H 0x100

/* Dependencies */
#pragma warning ( disable : 4201) /* nonstandard extension used : nameless struct/union */
#pragma warning ( disable : 4214) /* nonstandard extension used : bit field types other than int */
#include <windows.h>
#pragma warning ( default : 4201)
#pragma warning ( default : 4214)

/* Types */
struct SSbvdd;
typedef struct SMixer SMixer;

/* Functions */
extern SMixer* MixerInit( const struct SSbvdd*);
extern void MixerFinal( register SMixer*);
extern BYTE __fastcall MixerRead( register SMixer*);
extern void __fastcall MixerAddress( register SMixer*, BYTE);
extern void __fastcall MixerWrite( register SMixer*, BYTE);
extern BOOL __fastcall MixerIsStereoOut( register SMixer*);

#endif /* ndef MIXER_H */
/* End of file */
